	
	IS_EXE = 1
	
;=====[[ INCLUDES >>===\
; Note: The code requires ATC version 22 or later
.586
.model flat,stdcall
option casemap:none
option proc:private
include ..\..\wind.inc
include ../../dreamer.inc
include \masm32\include\wsock32.inc
includelib \masm32\lib\wsock32.lib
if IS_EXE	
	includelib ../JPG/JPG.lib
	memmove proc x,y,z
	ret
	memmove endp
else
	externdef iDREAMER:DREAMER
endif
PUBLIC StartupChess
	
	
	DecodeJpg proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	print textequ <PrintText>
;=======/	
;=====<< MACROS >>===\
	
	
SetBounds macro Whats,Mins,Maxs
local _donene
	cmp Whats,Mins
	jg @F
	mov Whats,Mins
	jmp _donene
	@@:
	cmp Whats,Maxs
	jl _donene
	mov Whats,Maxs
	_donene:
endm

m2m MACRO M1, M2
        push M2
        pop  M1
ENDM		
return MACRO Var1
	mov eax,Var1
	ret
ENDM


CTEXT macro Text:VARARG
	local szText
	.data
	szText byte Text, 0
	.code
	exitm <offset szText>	
endm
msgbox macro txt:VARARG
	invoke MessageBox,hwnd,CTEXT(txt),addr strTitle,0
endm
	
	
;=======/
;=====<< DATA >>===\
.data
	
	gfx_board	db 256 dup (0)
	
	figures 	dd 33 dup (0)
	
	thisHod		dd 0  ; hod na igrata
	
	hinst 		dd 0
	hdc		dd 0
	hdc_const	dd 0
	parts		dd 0
	focus		dd 0
	focusID 	dd 0
	hwnd		dd 0
	HEAP1 		dd 0
	
	strTitle db "uChess",0
	isMakingNewGame db 0
.code	
;=======/

	;enlist_procs = 1
	
include CLASS.inc	
	
		
	
		

		
;=====<< CLASS DEFINITIONS >>===\
	figure_figure 	proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	peshka_peshka 	proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	top_top	 	proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	kon_kon	 	proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	oficer_oficer 	proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	carica_carica 	proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	car_car	 	proto :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
	
class figure
	virtual figure:x,y,figura,ID
	virtual moveTo:x,y
	virtual draw
	virtual onTick
	
	long x
	long y
	long figura
	long ID
	long canMoveTo ; pointer to function
	long displayMoveTo
	
	;--- gfx:
	float gfx_x
	float gfx_y
	
endclass
	
	
class peshka,figure
	virtual peshka : x,y,figura,ID :  x,y,figura,ID
endclass
	
class top,figure
	virtual top : x,y,figura,ID :  x,y,figura,ID
endclass
	
class kon,figure
	virtual kon : x,y,figura,ID :  x,y,figura,ID
endclass
	
class oficer,figure
	virtual oficer : x,y,figura,ID :  x,y,figura,ID
endclass
	
class carica,figure
	virtual carica : x,y,figura,ID :  x,y,figura,ID
endclass
	
class car,figure
	virtual car : x,y,figura,ID :  x,y,figura,ID
endclass
;=======/
	
;=====[[ CONSTANTS >>===\
	; figures:	const		name in Bulgarian
	
	PAWN		equ 1		; peshka
	ROOK		equ 2		; top
	KNIGHT		equ 3		; kon
	BISHOP		equ 4		; oficer
	QUEEN		equ 5		; carica
	KING		equ 6		; car
	
	IS_BLACK	EQU 8
	
	PARTS_WID 	equ 571
	PARTS_HEI	equ 184
	
	SQUARE		EQU 45
	BOARD_WOOD	EQU 18
	BOARD_SIZE	EQU 396
	
	TEXT_HEI	EQU 100
	
	
ACTION_SIGN_IN equ 1
	
;=======/
	
;=====<< TOOLS >>===\
bb proc uses eax ebx ecx edx esi edi x,y,wid,hei,x2,y2
	invoke BitBlt,hdc,x,y,wid,hei,parts,x2,y2,SRCCOPY
	ret
bb endp
		
WhoIsAt proc uses ecx edx esi edi x,y
	mov esi,x
	mov edi,y
	xor ecx,ecx
   .while ecx<33
	mov eax,figures[ecx*4]
      .if eax && [eax].figure.x==esi && [eax].figure.y==edi
	ret
      .endif
	inc ecx
   .endw
	
	xor eax,eax
	ret
WhoIsAt endp
	
IsFriend proc uses ebx ecx edx x,y,me
	.if x>7 || y>7
		xor eax,eax
		ret
	.endif
	invoke WhoIsAt,x,y
	or eax,eax
	jz _ret
	mov eax,[eax].figure.figura
	shr eax,3
	mov ecx,me
	mov ecx,[ecx].figure.figura
	shr ecx,3
	xor eax,ecx
	xor eax,1
	and eax,1
	ret
 _ret:	xor eax,eax
	ret
IsFriend endp	
	
		
isMyTurn proc
	.if thisHod<3
		mov eax,thisHod
		shr eax,1
	.else
		mov eax,thisHod	
	.endif
	xor al,IamWhite
	and eax,1
	ret
isMyTurn endp
	
uatodw proc uses ebx ecx str1
	xor ecx,ecx
	mov ebx,str1
	
	@@:
	movzx eax,byte ptr[ebx]
	cmp al,"0"
	jl _ret
	cmp al,"9"
	jg _ret
	sub al,"0"
	imul ecx,10
	add ecx,eax
	inc ebx
	jmp @B
 _ret:	mov eax,ecx
	ret
uatodw endp
;=======/
	
	
;=====<< FIGURE >>===\
	
	
figure_figure proc me,x,y,figura,ID
	local baka
	m2m [ecx].figure.x,x
	m2m [ecx].figure.y,y
	m2m [ecx].figure.figura,figura
	m2m [ecx].figure.ID,ID
	mov eax,ID
	mov figures[eax*4],ecx
	
	;mov eax,x
	;imul eax,SQUARE
	;mov baka,eax
	;fild baka
	;fstp [ecx].figure.gfx_x
	
	mov [ecx].figure.canMoveTo,figure_canMoveTo
	mov [ecx].figure.displayMoveTo,figure_displayMoveTo
	ret
figure_figure endp
	
figure_$figure proc
	mov eax,[ecx].figure.ID
	mov figures[eax*4],0
	ret
figure_$figure endp
	
figure_canMoveTo proc me,x,y
	mov eax,1
	ret
figure_canMoveTo endp
;=======/
;=====<< MOVE.FIGURE >>===\
figure_moveTo proc me,x,y
	mov eax,x
	mov edx,y
	.if [ecx].figure.x==eax && [ecx].figure.y==edx
		.if focus==ecx
			mov focus,0
		.else
			mov focus,ecx
		.endif
		ret
	.endif
	
	invoke WhoIsAt,x,y
	.if eax
		delete eax
	.endif
	mov ecx,me
	mov eax,x
	mov edx,y
	mov [ecx].figure.x,eax
	mov [ecx].figure.y,edx
	
	.if y==7 || y==0
		mov eax,[ecx].figure.figura
		and eax,7
		.if eax==PAWN ; transform PAWN to QUEEN
			mov eax,[ecx].figure.figura
			and eax,8
			or eax,QUEEN
			mov [ecx].figure.figura,eax
			mov [ecx].figure.canMoveTo,carica_canMoveTo
			mov [ecx].figure.displayMoveTo,carica_displayMoveTo
		.endif
	.endif
	inc thisHod
	mov focus,0
	
 _ret:	ret
figure_moveTo endp
	
figure_displayMoveTo proc me,x,y
	; clear gfx board
	lea edi,gfx_board
	mov ecx,256/4
	xor eax,eax
	rep stosd
	
	ret
figure_displayMoveTo endp
	
figure_draw proc me
	local x,y,srcx,srcy,baka
	local rect:RECT
	
	mov eax,[ecx].figure.figura
	and eax,7
	dec eax
	imul eax,SQUARE
	mov srcx,eax
	mov eax,[ecx].figure.figura
	xor edx,edx
	shr eax,3
	jz @F
	add edx,2*SQUARE
	@@:
	mov eax,[ecx].figure.x
	xor eax,[ecx].figure.y
	and eax,1
	jz @F
	add edx,SQUARE
	@@:	
	mov srcy,edx
	
	mov eax,[ecx].figure.x
	.if IamWhite
	  sub eax,7
	  neg eax
	.endif
	imul eax,SQUARE
	mov x,eax
	mov eax,[ecx].figure.y
	.if IamWhite
	  sub eax,7
	  neg eax
	.endif
	imul eax,SQUARE
	mov y,eax
	fld [ecx].figure.gfx_x
	fistp baka
	mov esi,baka
	fld [ecx].figure.gfx_y
	fistp baka
	mov edi,baka
	add esi,BOARD_WOOD
	add edi,BOARD_WOOD
	add x,BOARD_WOOD
	add y,BOARD_WOOD
	
	
	.if esi==x && edi==y
		invoke bb,x,y,SQUARE,SQUARE,srcx,srcy
	.endif
	mov ecx,me
	;.if focus==ecx
		mov rect.left,esi
		add esi,SQUARE
		mov rect.right,esi
		mov rect.top,edi
		add edi,SQUARE
		mov rect.bottom,edi
		inc rect.left
		inc rect.top
		dec rect.bottom
		dec rect.right
		.data
			orange dd 0
			yellow dd 0
		.code
		.if !yellow
			invoke CreateSolidBrush,00FFFFh
			mov yellow,eax
			invoke CreateSolidBrush,0070BAEDh;00EDBA70h		;237,186,112
			mov orange,eax
		.endif
		mov eax,orange
		mov ecx,me
		.if ecx==focus
			mov eax,yellow
		.endif
		invoke FrameRect,hdc,addr rect,eax
		
	;.endif
	ret
figure_draw endp
	
.data
	f05 real4 0.5
.code
figure_onTick proc me
	local baka
	mov eax,[ecx].figure.x
	.if IamWhite
	  sub eax,7
	  neg eax
	.endif
	imul eax,SQUARE
	mov baka,eax
	fild baka
	fadd [ecx].figure.gfx_x
	if IS_EXE eq 0
		fadd f05 ; fix fpu truncation
	endif
	fmul f05
	fstp [ecx].figure.gfx_x
	
	mov eax,[ecx].figure.y
	.if IamWhite
	  sub eax,7
	  neg eax
	.endif
	imul eax,SQUARE
	mov baka,eax
	fild baka
	fadd [ecx].figure.gfx_y
	if IS_EXE eq 0
		fadd f05 ; fix fpu truncation
	endif
	fmul f05
	fstp [ecx].figure.gfx_y
	
	ret
figure_onTick endp
;=======/
	
;=====<< PESHKA >>===\
peshka_peshka proc me,x,y,figura,ID
	mov [ecx].figure.canMoveTo,peshka_canMoveTo
	ret
peshka_peshka endp
	
peshka_$peshka proc
	ret
peshka_$peshka endp
	
peshka_canMoveTo proc me,x,y
	mov ecx,me
	mov esi,[ecx].figure.x
	mov edi,[ecx].figure.y
	
	dec edi
	.if IamWhite
	 add edi,2
	.endif
	.if edi!=y
	 _bad:	xor eax,eax
		ret
	.endif
	mov edx,esi
	sub edx,x
	.if edx>100
		neg edx
	.endif
	cmp edx,1
	ja _bad
 .if edx==0 ; go forward
	; there must be no figure in front of me
	invoke WhoIsAt,x,y
	or eax,eax
	jnz _bad
 .else	; go left or right
	; there must be an enemy at x,y
	invoke WhoIsAt,x,y
	or eax,eax
	jz _bad
 .endif
	mov eax,1
	ret
peshka_canMoveTo endp	
;=======/
;=====<< TOP >>===\
top_top proc me,x,y,figura,ID
	mov [ecx].figure.canMoveTo,top_canMoveTo
	ret
top_top endp
	
top_$top proc
	ret
top_$top endp
	
top_canMoveTo proc uses ebx ecx edx esi edi me,x,y
	mov ecx,me
	mov esi,[ecx].figure.x
	mov edi,[ecx].figure.y
	
	.if esi!=x && edi !=y
	_bad:	xor eax,eax
		ret
	.endif
	
	; add obstacles
 .if esi != x ; we're moving horisontally  ---A--B-
	mov edx,1
	.if x<esi
	  mov edx,-1
	.endif
	add esi,edx
	.while esi !=x
	 invoke WhoIsAt,esi,edi
	 or eax,eax
	 jnz _bad
	 add esi,edx
	.endw
	
 .else	; we're moving vertically 
	mov edx,1
	.if y<edi
	  mov edx,-1
	.endif
	add edi,edx
	.while edi !=y
	 invoke WhoIsAt,esi,edi
	 or eax,eax
	 jnz _bad
	 add edi,edx
	.endw
 .endif	
	
	mov eax,1
	ret
top_canMoveTo endp	
;=======/
;=====<< KON >>===\
kon_kon proc me,x,y,figura,ID
	mov [ecx].figure.canMoveTo,kon_canMoveTo
	ret
kon_kon endp
	
kon_$kon proc
	ret
kon_$kon endp
	
kon_canMoveTo proc uses ebx ecx edx esi edi me,x,y
	mov ecx,me
	mov esi,[ecx].figure.x
	mov edi,[ecx].figure.y
	
	sub esi,x
	sub edi,y
	.if esi>100
		neg esi
	.endif
	.if edi>100
		neg edi
	.endif
	.if (esi==1 && edi==2) || (esi==2 && edi==1)
		mov eax,1
		ret
	.endif
	xor eax,eax
	ret
kon_canMoveTo endp	
;=======/
;=====<< OFICER >>===\
oficer_oficer proc me,x,y,figura,ID
	mov [ecx].figure.canMoveTo,oficer_canMoveTo
	mov [ecx].figure.displayMoveTo,oficer_displayMoveTo
	ret
oficer_oficer endp
	
oficer_$oficer proc
	ret
oficer_$oficer endp
	
oficer_canMoveTo proc uses ebx ecx edx esi edi me,x,y
	mov ecx,me
	mov esi,[ecx].figure.x
	mov edi,[ecx].figure.y
	sub esi,x
	sub edi,y
	
	.if esi >32
	neg esi
	.endif
	.if edi>32
	neg edi
	.endif
	.if esi !=edi
	_bad:	xor eax,eax
		ret
	.endif
	
	; add obstacles
	mov esi,[ecx].figure.x
	mov edi,[ecx].figure.y
	mov ebx,1
	mov edx,1
	.if esi>x
		mov ebx,-1
	.endif
	.if edi>y
		mov edx,-1
	.endif
	add esi,ebx
	add edi,edx
	.while esi!=x && edi!=y
		invoke WhoIsAt,esi,edi	
		or eax,eax
		jnz _bad
		add esi,ebx
		add edi,edx	
	.endw
	
	mov eax,1
	ret
oficer_canMoveTo endp
	
oficer_displayMoveTo proc me,x,y
	invoke figure_displayMoveTo,me,x,y
	ret
oficer_displayMoveTo endp
	
;=======/
;=====<< CARICA >>===\
carica_carica proc me,x,y,figura,ID
	mov [ecx].figure.canMoveTo,carica_canMoveTo
	mov [ecx].figure.displayMoveTo,carica_displayMoveTo
	ret
carica_carica endp
	
carica_$carica proc
	ret
carica_$carica endp
	
carica_canMoveTo proc uses ebx me,x,y
	invoke top_canMoveTo,me,x,y
	mov ebx,eax
	invoke oficer_canMoveTo,me,x,y
	or eax,ebx
	ret
carica_canMoveTo endp
	
carica_displayMoveTo proc me,x,y
	invoke figure_displayMoveTo,me,x,y
	ret
carica_displayMoveTo endp
	
;=======/
;=====<< CZAR >>===\
car_car proc me,x,y,figura,ID
	mov [ecx].figure.canMoveTo,car_canMoveTo
	mov [ecx].figure.displayMoveTo,car_displayMoveTo
	ret
car_car endp
	
car_$car proc
 .if !isMakingNewGame
	.if [ecx].figure.figura & IS_BLACK
		msgbox "Game Over, the White win!"
	.else
		msgbox "Game Over, the Black win!"
	.endif
 .endif
	ret
car_$car endp
	
car_canMoveTo proc uses ebx ecx edx esi edi me,x,y
	mov ecx,me
	mov esi,[ecx].figure.x
	mov edi,[ecx].figure.y
	sub esi,x
	sub edi,y
	.if esi>100
		neg esi
	.endif
	.if edi>100
		neg edi
	.endif
	mov eax,1
	.if esi>1 || edi >1
		xor eax,eax
	.endif
	ret
car_canMoveTo endp
	
car_displayMoveTo proc me,x,y
	invoke figure_displayMoveTo,me,x,y
	ret
car_displayMoveTo endp
	
;=======/
		
	
	
	
game struct
	crc dd ?
	msg dd ?
	w dd ?
	l dd ?	
	e dd ?
game ends
		
	
.data	
	
	CHESS_PORT dd 3162
	
	
	WM_SOCKET equ WM_USER+1166
	WM_NEWGAME equ WM_USER+1167
	
	AI_NEWGAME equ 1
	AI_ROTATEBOARD equ 2  ; w= "you should be"
	AI_MOUSEDOWN equ 3  ; w= x, l= y  ;translated x and y
	AI_MOUSEMOVE equ 4 ; w=x,l=y
	AI_MESSAGE equ 5 ; w = len
	AI_MOVEFIGURE equ 6
	
	
	
	
	IamWhite db 1
	clientPresent dd 0
	serverPresent dd 0
	
	clientDisconnected dd 0
	serverConnected dd 0
	
	sSocket	dd 0 ; server socket
	cSocket dd 0 ; client socket
	
	hClient dd 0 ; the other dude
	
	WSAdata WSADATA <>
	sin sockaddr_in <>
	
	strClientIP db "127.0.0.1"
		    db 50 dup(0)
	strClientIP_len dd 9
	
	strClientPort db "3162"
		      db 10 dup (0)
	strClientPort_len dd 4
	
	hisMouse POINT <> ; target
	hisMouse_x real4 ?
	hisMouse_y real4 ?
	hisMouse_speed real4 0.5
	
.data?
	ReceivedData dd 256 dup (?)
.code	
	
	
NetOnMouseDown proc x,y
	
	
	.if focus
		mov eax,focus
		mov ebx,[eax].figure.x
		mov ecx,[eax].figure.y
		.if x==ebx && y==ecx
			mov focus,0
			ret
		.endif
		invoke IsFriend,x,y,focus
		.if eax
			invoke WhoIsAt,x,y
			mov focus,eax
			ret
		.endif
		mov ecx,focus
		Scall [ecx].figure.canMoveTo,ecx,x,y
		.if eax
	 	 push focus
		 iCall focus,figure,moveTo,x,y
		 pop eax
	 	SendCommand proto :DWORD,:DWORD,:DWORD,:DWORD
	 	 invoke SendCommand,AI_MOVEFIGURE,[eax].figure.ID,x,y
		.endif
	.else
		invoke WhoIsAt,x,y
		or eax,eax
		jz _ret
		mov edx,[eax].figure.figura
		shr edx,3
		xor dl,IamWhite
		jz _ret
		mov focus,eax
	.endif
	
 _ret:	ret
NetOnMouseDown endp
	
	
	
SendCommand proc msg,w,l,e
	local g:game
	mov g.crc,"ILKO"
	m2m g.msg,msg
	m2m g.w,w
	m2m g.l,l
	m2m g.e,e
	;.if msg!=AI_MOUSEMOVE
	;PrintDec msg
	;PrintDec w
	;PrintDec l
	;PrintDec e
	;PrintLine
	;.endif
	.if cSocket
		invoke send, cSocket, addr g, sizeof game, 0
	.endif
	ret
SendCommand endp	
	
	
TranslateCommand proc 
	lea ebx,ReceivedData
	cmp [ebx].game.crc,"ILKO"
	jne _ret
	mov eax,[ebx].game.msg
	;.if eax !=AI_MOUSEMOVE
	;PrintDec [ebx].game.msg
	;PrintDec [ebx].game.w
	;PrintDec [ebx].game.l
	;PrintDec [ebx].game.e
	;PrintLine
	;.endif
 .if eax==AI_NEWGAME
	mov eax,[ebx].game.w
	and eax,1
	mov IamWhite,al
	call InitBoard
 .elseif eax==AI_ROTATEBOARD
	mov eax,[ebx].game.w
	and eax,1
	mov IamWhite,al
 .elseif eax==AI_MOUSEDOWN
	invoke isMyTurn
	.if !eax
	invoke WhoIsAt,[ebx].game.w,[ebx].game.l
	mov focus,eax	
	.endif
 .elseif eax==AI_MOUSEMOVE
	fild [ebx].game.w
	fstp hisMouse.x
	fild [ebx].game.l
	fstp hisMouse.y
 .elseif eax==AI_MESSAGE
 .elseif eax==AI_MOVEFIGURE
	mov eax,[ebx].game.w
	mov eax,figures[eax*4]
	mov esi,[ebx].game.l
	mov edi,[ebx].game.e
	.if eax
	  iCall eax,figure,moveTo,esi,edi
	.endif
 .endif	
 _ret:	ret
TranslateCommand endp
	
ToggleWhite proc
	movzx eax,IamWhite
	invoke SendCommand,AI_ROTATEBOARD,eax,0,0
	xor IamWhite,1
	ret
ToggleWhite endp
	
;=====<< CREATE_SERVER_AND_CLIENT >>===\
CreateServer proc 
	
	;ret
	
	
	
	invoke WSAStartup,0101h,ADDR WSAdata
	or eax,eax
	jnz _ret
	invoke socket,AF_INET,SOCK_STREAM,0
	cmp eax,INVALID_SOCKET
	je _ret
	mov sSocket,eax
	invoke WSAAsyncSelect,sSocket,hwnd,WM_SOCKET,FD_ACCEPT+FD_READ
	cmp eax,INVALID_SOCKET
	je _ret
	invoke htons,CHESS_PORT
	mov sin.sin_port, ax
	mov sin.sin_family, AF_INET
	mov sin.sin_addr, INADDR_ANY
	invoke bind, sSocket, addr sin, sizeof sin
	invoke listen,sSocket,3
	
	ret
 _ret:	msgbox "Cannot make server"
	;;invoke ExitProcess,0
	ret
CreateServer endp
	
	
TryToConnect proc
	invoke socket,AF_INET,SOCK_STREAM,0
	cmp eax,INVALID_SOCKET
	je _ret
	mov cSocket,eax
	invoke WSAAsyncSelect,cSocket,hwnd,WM_SOCKET, FD_CONNECT+FD_READ+FD_CLOSE
	cmp eax,INVALID_SOCKET
	je _ret
	invoke htons,CHESS_PORT
	mov sin.sin_port, ax
	mov sin.sin_family, AF_INET
	invoke inet_addr, addr strClientIP
	mov sin.sin_addr, eax
	invoke connect, cSocket, addr sin, sizeof sin
	
 _ret:	ret
TryToConnect endp
	
	
CloseConnection proc 
	invoke closesocket,sSocket
	invoke closesocket,cSocket
	invoke WSACleanup
	ret
CloseConnection endp
;=======/
;=====<< NETLOOP >>===\
NetLoop proc w,l
	mov eax,l
	.if ax==FD_CONNECT
		shr eax,16
		.if !ax
			mov serverPresent,1
			mov serverConnected,1
		.else	
			msgbox "Could not connect to given PC"
			mov serverConnected,0
		.endif
	.elseif ax==FD_ACCEPT
		shr eax,16
		.if !ax
			mov clientPresent,1
			invoke accept,sSocket,0,0
			mov hClient,eax
		.endif
	.elseif ax==FD_READ
		shr eax,16
		.if !ax
			mov ReceivedData[0],0
			invoke recv, hClient, addr ReceivedData, 1024,0			
			invoke TranslateCommand
		.endif
	.elseif ax==FD_CLOSE
		shr eax,16
		.if !ax
			invoke closesocket, cSocket
			mov sSocket,0
			mov clientDisconnected,1
		.endif
	.endif
	ret
NetLoop endp
;=======/
		
	
.data
	helpText db "in the window, type one of the 2 commands:",13,10
	db '"new game" - hehe',13,10
	db '"connect" or F5 - write IP of your friend, play chess on port 3162. ',13,10
	db 'Press TAB to rotate the board',13,10
	db "You'll get a smilie in right-top corner if your mate connected to you. He also must get a smilie, so that the game starts. "
	db 'Before you both start, type "new game" and then one of you must press TAB. ',13,10
	db "if you want to change the port, make a file ChessPort.txt , and write there the port number",13,10
	db "Have Fun!"
	
	db 0
.code
	
;=====<< ON_MOUSE >>===\
OnMouse proc x,y
	local clickedID
	.if x<BOARD_WOOD || y<BOARD_WOOD || x>=BOARD_WOOD+8*SQUARE || y>=BOARD_WOOD+8*SQUARE
		ret
	.endif
	mov eax,x
	sub eax,BOARD_WOOD
	xor edx,edx
	mov ecx,SQUARE
	div ecx
	mov x,eax
	mov eax,y
	sub eax,BOARD_WOOD
	xor edx,edx
	mov ecx,SQUARE
	div ecx
	mov y,eax
	
	.if IamWhite
		sub x,7
		neg x
		sub y,7
		neg y
	.endif
	
	invoke isMyTurn
  .if eax 
	invoke NetOnMouseDown,x,y
	invoke SendCommand,AI_MOUSEDOWN,x,y,0
  .endif	
	ret
OnMouse endp
	
;=======/
;=====<< TICK AND PAINT >>===\
OnTick proc
	xor ecx,ecx
	.while ecx<33
	mov eax,figures[ecx*4]
	.if eax
	push ecx
	iCall eax,figure,onTick
	pop ecx
	.endif
	inc ecx
	.endw
	
	
	fld hisMouse.x
	fmul hisMouse_speed
	fld1
	fsub hisMouse_speed
	fmul hisMouse_x
	fadd
	fstp hisMouse_x
	fld hisMouse.y
	fmul hisMouse_speed
	fld1
	fsub hisMouse_speed
	fmul hisMouse_y
	fadd
	fstp hisMouse_y
	
	
	.if clientPresent
	 inc clientPresent
	.endif
	.if clientDisconnected
	 inc clientDisconnected
	.endif
	.if serverConnected
	 inc serverConnected
	.endif
	ret
OnTick endp
	
.data
	isConsole dd 0
.code
	
	
OnPaint proc uses ebx esi edi
	local hdc2,baka
	local rect:RECT
	local pt:POINT
	
	
	invoke BitBlt,hdc,0,0,BOARD_SIZE,BOARD_SIZE,hdc_const,0,0,SRCCOPY
	
	;-------[ draw A1..H8 ]--------\
	mov eax,33
	mov ebx,45
	mov ecx,33+7*45
	mov edx,-45
	.if IamWhite==0
	add eax,7*45
	neg ebx
	mov ecx,33
	neg edx
	.endif
	mov esi,279
	mov baka,0
	.while baka<8
	invoke bb,eax,381,11,13,esi,3 ; A..H
	invoke bb,eax,3,  11,13,esi,3 ; A..H
	invoke bb,4  ,ecx,11,13,esi,17; 1..8
	invoke bb,381,ecx,11,13,esi,17; 1..8
	add eax,ebx
	add ecx,edx
	add esi,12
	inc baka
	.endw
	;------------------------------/
	
	
	
	xor ecx,ecx
	.while ecx<33
		mov eax,figures[ecx*4]
		push ecx
		.if eax
			iCall eax,figure,draw
		.endif
		pop ecx
		inc ecx
	.endw
	
	
	.if isConsole
	invoke bb,0,0,19,20,485,51
	invoke TextOut,hdc,22,2,addr strClientIP,strClientIP_len
	.endif
	
	.if clientPresent && clientPresent<100
	  invoke bb,377,17,19,21,462,51
	.endif
	.if clientDisconnected && clientDisconnected<100
	 invoke bb,377,17,19,21,462,28
	.endif
	.if serverConnected && serverConnected<100
	  invoke bb,378,378,18,18,482,28
	.endif
	
	invoke isMyTurn
	.if !eax
	 invoke bb,288,4,70,15,454,3
	.endif
	
	
	; paint the friend's mouse 
	fld hisMouse_x
	fistp pt.x
	fld hisMouse_y
	fistp pt.y
 .if esi || edi
	mov esi,pt.x
	mov edi,pt.y
	invoke MoveToEx,hdc,esi,edi,0
	invoke LineTo,hdc,esi,addr [edi+14]
	invoke LineTo,hdc,addr [esi+3],addr [edi+11]
	invoke LineTo,hdc,addr [esi+7],addr [edi+18]
	invoke LineTo,hdc,addr [esi+9],addr [edi+17]
	invoke LineTo,hdc,addr [esi+6],addr [edi+10]
	invoke LineTo,hdc,addr [esi+10],addr [edi+10]
	invoke LineTo,hdc,esi,edi
 .endif
	
	invoke GetDC,hwnd
	mov hdc2,eax
	invoke BitBlt,hdc2,0,0,BOARD_SIZE,BOARD_SIZE,hdc,0,0,SRCCOPY
	invoke ReleaseDC,hwnd,hdc2
	
	ret
OnPaint endp
;=======/
;=====<< INIT WINDOW >>===\
board_gif:
include res/back.inc
board_gif_size equ ($-board_gif)
parts_gif:
include res/parts.inc
parts_gif_size equ ($-parts_gif)
	
InitWindow proc 
	local file1,baka
	local wc:WNDCLASSEX
	local rect:RECT
	local str1[100]:byte
	.data
		szClassName db "asmChess by Ultrano",0
		szClassRegi db 0
	.code
	;==================================================
        ; Fill WNDCLASSEX structure with required variables
        ;==================================================
	
        mov wc.cbSize,         sizeof WNDCLASSEX
        mov wc.style,          0
        mov wc.lpfnWndProc,    offset WindowProc      
        mov wc.cbClsExtra,     NULL
        mov wc.cbWndExtra,     NULL
        m2m wc.hInstance,      hinst               ; instance handle
        mov wc.hbrBackground,  0
        mov wc.lpszMenuName,   NULL
        mov wc.lpszClassName,  offset szClassName  ; window class name
	invoke LoadIcon,hinst,4000
        mov wc.hIcon,          eax
          invoke LoadCursor,NULL,IDC_ARROW         ; system cursor
        mov wc.hCursor,        eax
        mov wc.hIconSm,        0
	
	
        invoke RegisterClassEx, ADDR wc     ; register the window class
	
	
	
	invoke CreateCompatibleDC,0
        mov hdc,eax
	invoke GetDC,0
	invoke CreateCompatibleBitmap,eax,BOARD_SIZE,BOARD_SIZE
	invoke SelectObject,hdc,eax
	
	invoke CreateCompatibleDC,0
        mov hdc_const,eax
	invoke GetDC,0
	invoke CreateCompatibleBitmap,eax,BOARD_SIZE,BOARD_SIZE
	invoke SelectObject,hdc_const,eax
	invoke DecodeJpg,offset board_gif,board_gif_size,hdc_const,BOARD_SIZE,BOARD_SIZE
	
	;now fractal copy the board
	invoke BitBlt,hdc_const,108,18,90,90,hdc_const,18,18,SRCCOPY
	invoke BitBlt,hdc_const,198,18,180,90,hdc_const,18,18,SRCCOPY
	invoke BitBlt,hdc_const,18,108,360,90,hdc_const,18,18,SRCCOPY
	invoke BitBlt,hdc_const,18,198,360,180,hdc_const,18,18,SRCCOPY
	
	
	invoke CreateCompatibleDC,0
        mov parts,eax
	invoke GetDC,0
	invoke CreateCompatibleBitmap,eax,PARTS_WID,PARTS_HEI
	invoke SelectObject,parts,eax
	invoke DecodeJpg,offset parts_gif,parts_gif_size,parts,PARTS_WID,PARTS_HEI
	
	
	
	
	
	
	mov rect.left,0
	mov rect.top,0
	mov rect.right,BOARD_SIZE
	mov rect.bottom,BOARD_SIZE;+TEXT_HEI
	invoke AdjustWindowRect,addr rect,WS_POPUPWINDOW or WS_VISIBLE or WS_CAPTION or WS_MINIMIZEBOX,0
	mov eax,rect.left
	sub rect.right,eax
	mov eax,rect.top
	sub rect.bottom,eax
	
	invoke CreateWindowEx,0,
				ADDR szClassName,
				ADDR szClassName,
				WS_POPUPWINDOW or WS_VISIBLE or WS_CAPTION or WS_MINIMIZEBOX,
				100,100,rect.right,rect.bottom,
				0,NULL,
				hinst,NULL
	mov hwnd,eax
	
	;invoke CreateWindowEx,0,CTEXT("Edit"),0,WS_VISIBLE or WS_CHILD or ES_MULTILINE,\
	;	0,BOARD_SIZE,BOARD_SIZE,TEXT_HEI,\
	;	hwnd,1,hinst,NULL
	invoke SetTimer,hwnd,1,50,0
	
	
	invoke CreateFile,CTEXT("ChessPort.txt"),GENERIC_READ,0,0,OPEN_EXISTING,0,0
	.if eax !=-1
		mov file1,eax
		xor eax,eax
		mov ecx,100/4
		lea edi,str1
		rep stosd
		invoke ReadFile,file1,addr str1,100,addr baka,0
		invoke CloseHandle,file1
		invoke uatodw,addr str1
		.if eax
			mov CHESS_PORT,eax
		.endif
		lea ebx,str1
		@@:
		cmp byte ptr[ebx],0
		je _donefile
		cmp byte ptr[ebx],10
		je @F
		inc ebx
		jmp @B
		@@:
		inc ebx
		lea ecx,strClientIP
		mov strClientIP_len,-1
		@@:
		mov al,[ebx]
		mov [ecx],al
		inc ebx
		inc ecx
		inc strClientIP_len
		or al,al
		jnz @B
		_donefile:
	.endif
	ret
InitWindow endp
;=======/
;=====<< EASTER EGG >>===\
On_EasterEgg macro text,action:VARARG
	local txt1,phase1
	.data
		phase1 db 0
		txt1   db text,0
	.code
	movzx eax,phase1
	movzx eax,txt1[eax]
	.if eax==w  ; if this pressed key is the next we expect
		inc phase1 
		movzx eax,phase1
		.if !txt1[eax] ; if we've typed the whole text correctly
			mov phase1,0
			
			action ; invokes whatever code this defines	
		.endif
	.else
		mov phase1,0
	.endif
endm
	
;=======/
;=====<< WINDOW PROC >>===\
WindowProc proc uses ebx esi edi hWnd,msg,w,l
	local ps:PAINTSTRUCT
	.if msg==WM_CLOSE
		invoke DestroyWindow,hWnd
		invoke PostQuitMessage,0
	.elseif msg==WM_PAINT
		invoke BeginPaint,hWnd,addr ps
		invoke EndPaint,hWnd,addr ps
	.elseif msg==WM_LBUTTONDOWN
		mov eax,l
		mov ecx,eax
		movsx eax,ax
		shr ecx,16
		movsx ecx,cx
		invoke OnMouse,eax,ecx
	.elseif msg==WM_MOUSEMOVE
		mov eax,l
		mov ecx,eax
		movsx eax,ax
		shr ecx,16
		movsx ecx,cx
		invoke SendCommand,AI_MOUSEMOVE,eax,ecx,0
	.elseif msg==WM_TIMER
		invoke OnTick
		invoke OnPaint
		xor eax,eax
	.elseif msg==WM_KEYUP && w==VK_F1
		invoke MessageBox,hWnd,addr helpText,CTEXT("Chess by Ultrano"),MB_ICONINFORMATION
	.elseif msg==WM_KEYUP && w==VK_F5
		jmp _setconsole
	.elseif msg==WM_KEYUP && w==VK_F12
		invoke PostMessage,hWnd,WM_NEWGAME,0,0
	.elseif msg==WM_CHAR
		On_EasterEgg "white",invoke ToggleWhite
		On_EasterEgg "new game",invoke PostMessage,hWnd,WM_NEWGAME,0,0
		On_EasterEgg "exit",invoke PostQuitMessage,0
		On_EasterEgg "connect",jmp _setconsole	
		xor eax,eax
		.if w==8 && isConsole      	; backspace
			mov eax,strClientIP_len
			.if eax
				mov strClientIP[eax],0
				dec strClientIP_len
			.endif
		.elseif w==9
			invoke ToggleWhite
		.elseif eax==-1 ; never
			_setconsole:
			mov isConsole,1
			ret
		.elseif w==13 && isConsole; enter
			mov isConsole,0
			invoke TryToConnect
		.elseif w==27 	; escape
			mov isConsole,0
		.elseif isConsole
			mov eax,strClientIP_len
			.if eax<49
				mov edx,w
				mov strClientIP[eax],dl
				mov strClientIP[eax+1],0
				inc strClientIP_len
			.endif
		.endif	
	.elseif msg==WM_SOCKET
		invoke NetLoop,w,l
	.elseif msg==WM_NEWGAME
		call InitBoard
		movzx eax,IamWhite
		xor eax,1
		invoke SendCommand,AI_NEWGAME,eax,0,0
	.else
		invoke DefWindowProc,hWnd,msg,w,l
	.endif
	ret
WindowProc endp
;=======/
	
;=====<< INIT BOARD >>===\
InitBoard proc 
	; clear gfx board
	lea edi,gfx_board
	mov ecx,256/4
	xor eax,eax
	rep stosd
	
	mov focus,0
	mov thisHod,0
	mov isMakingNewGame,1
	xor ecx,ecx
	.while ecx<33
	mov eax,figures[ecx*4]
	.if eax
		push ecx
		delete eax
		pop ecx
	.endif
	inc ecx
	.endw
	mov isMakingNewGame,0
	
	
	mov eax,new(peshka,   0,1,PAWN,1)
	mov eax,new(peshka,   1,1,PAWN,2)
	mov eax,new(peshka,   2,1,PAWN,3)
	mov eax,new(peshka,   3,1,PAWN,4)
	mov eax,new(peshka,   4,1,PAWN,5)
	mov eax,new(peshka,   5,1,PAWN,6)
	mov eax,new(peshka,   6,1,PAWN,7)
	mov eax,new(peshka,   7,1,PAWN,8)
	
	mov eax,new(top,   0,0,ROOK,9)
	mov eax,new(kon,   1,0,KNIGHT,10)
	mov eax,new(oficer,2,0,BISHOP,11)
	mov eax,new(car,   3,0,KING,12)
	mov eax,new(carica,4,0,QUEEN,13)
	mov eax,new(oficer,5,0,BISHOP,14)
	mov eax,new(kon,   6,0,KNIGHT,15)
	mov eax,new(top,   7,0,ROOK,16)
	
	
	mov eax,new(peshka,   0,6,PAWN+IS_BLACK,17)
	mov eax,new(peshka,   1,6,PAWN+IS_BLACK,18)
	mov eax,new(peshka,   2,6,PAWN+IS_BLACK,19)
	mov eax,new(peshka,   3,6,PAWN+IS_BLACK,20)
	mov eax,new(peshka,   4,6,PAWN+IS_BLACK,21)
	mov eax,new(peshka,   5,6,PAWN+IS_BLACK,22)
	mov eax,new(peshka,   6,6,PAWN+IS_BLACK,23)
	mov eax,new(peshka,   7,6,PAWN+IS_BLACK,24)
	
	
	mov eax,new(top,   0,7,ROOK+IS_BLACK,	25)
	mov eax,new(kon,   1,7,KNIGHT+IS_BLACK,	26)
	mov eax,new(oficer,2,7,BISHOP+IS_BLACK,	27)
	mov eax,new(car,   3,7,KING+IS_BLACK,	28)
	mov eax,new(carica,4,7,QUEEN+IS_BLACK,	29)
	mov eax,new(oficer,5,7,BISHOP+IS_BLACK,	30)
	mov eax,new(kon,   6,7,KNIGHT+IS_BLACK,	31)
	mov eax,new(top,   7,7,ROOK+IS_BLACK,	32)
	
	
	ret
InitBoard endp
;=======/
	
PaintBoard proc wind_hdc
	ret
PaintBoard endp
	
	
	
	
;=====<< MAIN >>===\
StartupChess proc 
	local msg:MSG
	invoke GetProcessHeap
	mov HEAP1,eax
	invoke GetModuleHandle,0
	mov hinst,eax	
	
	invoke InitBoard
	invoke InitWindow
	
	invoke CreateServer
	
	samas:
	invoke GetMessage,addr msg,0,0,0
	cmp eax,0
	je mamaas
	invoke TranslateMessage,addr msg
	invoke DispatchMessage,addr msg
	jmp samas
mamaas:	
	
	
	invoke CloseConnection
	
	ret
StartupChess endp
	
;=======/
;=====[[ CODE START >>===\
if IS_EXE
start:	
	
	invoke StartupChess
	invoke ExitProcess,0
endif
end start
;=======/
	
		