	
;=====<< COPYRIGHT >>===\
; 
;     "ATC" wrapper/oop for asm   VERSION 23
; 
; Author: Ilian Dinev [Ultrano]
; ultrano@ultrano.com  
; best viewed with my XASM 
;=======/
	
	
;=====<< SWITCHES >>===\
;-------[ OOP switches !!!! ]--------------------------------------------------------------\
ifndef enlist_procs
	
	;----------\
	enlist_procs = 0  	; 1 = automatically generate procedures to ECHO, XASM shows it best. 
	;----------/		; Will produce symbol redefinition, that you have to clear yourself 
				; (when you use inheritage)
endif
	
ifndef DisplayClassHardcode
	
	;------------------\
	DisplayClassHardcode 	equ 0  ; whether to write hard.code to xasm output.
	;------------------/
	
endif

ifndef FirstParameterIsMe
	
	;----------------\
	FirstParameterIsMe	equ 1  ; all functions will be like CObject_doit proc me,var1,var2 ; otherwise "me" is skipped
	;----------------/
	
endif
	
;------[ ADVANCED OPTIONS ]---------------------------------\
; not for newbies with the ATC!
ifndef DisplayClassHardMembers
	DisplayClassHardMembers	= 0	; - the twin-bro of DisplayClassHardcode
endif
ifndef DisplayClassHard_bind
DisplayClassHard_bind	= 1	; - splits the normal hardcode output (the two twin-bros above),
				;   only for better readability
endif

;; AdjustClassStack	= 1	; - define if you want auto adjustment, a rare thing to do.
;; SpeedyClass 		= 1	; - if you want to compile the hardcoded stuff instead		
DefaultClassName textequ <> 	; - no need to touch
;------------------------------------------------------------------------------------------/
;=======/
;=====<< INIT SOME GLOBAL VARS >>===\
@current_class textequ <>
@parent_class textequ <>
if DisplayClassHard_bind AND DisplayClassHardcode
		DisplayClassHardMembers = 1
endif
	
if enlist_procs eq 1
	.err <[--------- End of list of procedures -------]>
endif	
	
if DisplayClassHardcode
	.err <---------- End of list of structure defs -->
endif
	
if DisplayClassHardMembers
	.err <---------- End of list of class members -->
endif
	
;=======/
	
;=====<< END CLASS >>===\
	
	
endclass MACRO
	local baka,cName,baka2,tab,baka3,baka4,Parent,ParentNew,Constructor,ParentDelete,Destructor
	local DisplayedFunc,desen,foundDele,opAsaTtrib,ConstructorArgs,ParentArgs,ThisFuncName
	
	
	if SpeedyClass
	  exitm
	endif
	
	baka CATSTR @current_class,< ends>
	baka
	if DisplayClassHardcode
		%echo baka
	endif
	
	cName textequ <@current_class>
	ConstructorArgs CATSTR cName,<_$NewArgs>
	
	@global_virtuals_num = 0
	@global_done_virtuals = 0
	@enlist_class_virtuals cName  ; start building structure and register virtual functions
	
	baka CATSTR @current_class,<_$virt_table>
	baka:
	if DisplayClassHardcode
		echo 
		%echo baka:
	endif
	
	if enlist_procs
		if FirstParameterIsMe
			ifnb ConstructorArgs
			%echo @current_class&_&@current_class proc me,ConstructorArgs
			else
			%echo @current_class&_&@current_class proc me
			endif
		else
			%echo @current_class&_&@current_class proc ConstructorArgs
		endif
		echo      ret
		%echo @current_class&_&@current_class endp	
		echo 
		
		%echo @current_class&_$&@current_class proc 
		echo      ret
		%echo @current_class&_$&@current_class endp	
		echo 
	endif
	
	baka2=0
   while baka2 LT @global_done_virtuals
	
	baka textequ GetVar(<@built_f2_>,%baka2)	
	ThisFuncName textequ GetVar(<@built_f_>,%baka2)
	ThisFuncName CATSTR @current_class,<_>,ThisFuncName
	;%echo ThisFuncName
	
	if enlist_procs AND (baka2 ne 0)
		baka4 CATSTR baka,<$d>		; Enlist Procs -------\
		%echo baka proc baka4		;
	  	echo ret			;         ^_^
		%echo baka endp			;
		echo 				;---------------------/
	else
		baka4 textequ GetVar(<@built_f_>,%baka2)	
		baka4 CATSTR @current_class,<_>,baka4
		;baka4&$r textequ <baka>
		
		if HostedClass  ; if normal, then
		 dd baka   	; register in table
		endif
		if DisplayClassHardcode
			%echo dd baka
		endif
		if DisplayClassHardMembers
			%echo baka4&&$r textequ <baka>
		endif
		
		baka textequ GetVar(<@built_f_>,%baka2)
		baka CATSTR @current_class,<_>,baka,<$>
		baka = baka2
		
		if DisplayClassHardMembers
			DisplayedFunc CATSTR baka,< equ >,%baka2
			%echo DisplayedFunc
		endif
		
		
	endif
   baka2=baka2+1
   endm
	
	
	
	
	
	;----< create real constructor >--------\
	
if HostedClass
	
baka CATSTR @current_class,<___>,@current_class
Parent CATSTR @current_class,<_$Parent>
ParentNew CATSTR Parent,<___>,Parent
ParentDelete CATSTR Parent,<___$delete>
Constructor CATSTR @current_class,<_>,@current_class
Destructor CATSTR @current_class,<_$>,@current_class
ParentArgs CATSTR @current_class,<_$ParentArgs>

	
  baka proc ConstructorArgs	; Object___Object    +args
	ifdif Parent,<>
	 push ecx
		ifnb ParentArgs
		  invoke ParentNew,ParentArgs
		else 
		  invoke ParentNew
		endif
	 pop ecx
	endif
	
	ifdif ConstructorArgs,<>
	   if FirstParameterIsMe
	     invoke Constructor,ecx,ConstructorArgs
	   else
	     invoke Constructor,ConstructorArgs
	   endif
	else
	   if FirstParameterIsMe
	     push ecx
	     call Constructor
	   else
	     call Constructor
	   endif
	endif
	
	ret
  baka endp
	
if DisplayClassHardcode	
	
	
	
	%echo cName&&_$ParentArgs textequ <ParentArgs>
	%echo cName&&_$NewArgs textequ <ConstructorArgs>
	
	baka2 = @CatStr(%@current_class,<_$HasCode>)
	baka3 CATSTR %baka2
	%echo cName&&_$HasCode = baka3
	echo 
	
	
	
	echo
 %echo baka proc ConstructorArgs
	ifdif Parent,<>
	  echo push ecx
	  %echo call ParentNew
	  echo pop ecx
	endif
	
	
	ifnb ConstructorArgs
	   if FirstParameterIsMe
	     %echo invoke Constructor,ecx,ConstructorArgs
	   else
	     %echo invoke Constructor,ConstructorArgs
	   endif
	else
	   if FirstParameterIsMe
	     echo push ecx
	    %echo call Constructor
	   else
	     %echo call Constructor
	   endif
	endif
	echo ret
 %echo baka endp
	
endif
	;--------------------------------------/
	
	
	;-------< Create real destructor >----\
  baka CATSTR @current_class,<___$delete>
	
	
	
  baka proc exitcode  ; Object___$Object
	push ecx
	    if FirstParameterIsMe
	        push ecx
	    endif
	    call Destructor
	pop ecx
	
	ifdif Parent,<>
	 push ecx
	 invoke ParentDelete,exitcode
	 pop ecx
	else
	 free ecx
	endif
	
	ret
  baka endp	
	
if DisplayClassHardcode	
	%echo baka proc exitcode
	echo push ecx
	if FirstParameterIsMe
	 echo push ecx
	endif 
	%echo call Destructor
	echo pop ecx
	
	ifdif Parent,<>
	echo push ecx
	%echo invoke ParentDelete,exitcode
	echo pop ecx
	else
	echo free ecx
	endif
	
	echo ret
  %echo baka endp	
endif	
	
	
	;-------------------------------------/
	
endif ; if HostedClass
		
	@current_class textequ <>
	
	
	
	
endm	
;=======/
;=====<< DEFINE DATA IN CLASS >>===\
AddClassData MACRO vName
	local cName,cvn,cvt
	
	if SpeedyClass
	  exitm
	endif
	
	
	cName textequ <@current_class>
	cvt CATSTR cName,<_$vn>
	cvn equ cvt ; number of variables, already existing
	cvt CATSTR cName,<_$vn_>
	cvt CATSTR cvt,%cvn
	@CatStr(cvt,< textequ <&vName>>)
	cvt CATSTR cName,<_$vn>
	cvt = cvt +1
	vName
	if DisplayClassHardcode
	 %echo vName
	endif
endm
	float MACRO var1
		AddClassData <var1 real4 ?>
	endm
	double MACRO var1
		AddClassData <var1 real8 ?>
	endm
	long MACRO var1
		AddClassData <var1 dd ?>
	endm
	char MACRO var1
		AddClassData <var1 db ?>
	endm
	short_int MACRO var1
		AddClassData <var1 dw ?>
	endm
	des MACRO var1
		AddClassData <var1 !<!>>
	endm
	
	dea MACRO dataName
		AddClassData <dataName dup!(!<!>!)> 
	endm
	
;=======/
;=====<< CLASS >>===\
class MACRO cName:REQ,ParentClass
	local baka
	
	ifndef HostedClass
		HostedClass=1
	endif
	
	ifndef SpeedyClass
		SpeedyClass=0
	endif
	
	
	
	.code
	
	if SpeedyClass
		exitm
	endif
	
	
	;--< check for errors >------------------------------\
	ifdef cName&_$IsDefined
		.err <The class "&cName" is already defined!!>
	endif
	ifdef @current_class
	ifdif @current_class,<>
		.err <Do not create the class "&cName" before you finish defining the other class!!>
	endif
	endif
	ifdif <ParentClass>,<>
	ifndef ParentClass&_$Parent 
		.err <The class "&ParentClass" does not exist, though wanted by class "&cName">
	endif
	endif
	;----------------------------------------------------/
	
	;---< set up global variables >---------\
	@current_class textequ <cName>
	@parent_class  textequ <ParentClass>
	
	cName&_$IsDefined = 1
	cName&_$vfn = 0 ; virtual functions num
	cName&_$vn = 0  ; variables num
	cName&_$Parent textequ <ParentClass>
	cName&_$HasDestructor = 0
	cName&_$HasCode = HostedClass
	cName&_$NewArgs textequ <>
	cName&_$ParentArgs textequ <>
	;---------------------------------------/
	
	
	
	
	
	;---[ start up struct ]-------------------------------\
	if DisplayClassHardcode
	   echo 
	   %echo cName struct
	endif
	
cName struct
	
	ifidn <ParentClass>,<>
		long $virtual_table  ; virtual table ptr
	else
		@enlist_class_variables <ParentClass>
	endif
	
	
	;-----------------------------------------------------/
	
	virtual __$delete
	
	
endm
;=======/
;=====<< STRIP ARGUMENTS >>===\
StripArguments macro var1:VARARG
	local char1,txt
	txt textequ <>
	forc char1,<var1>
	 ifidn <char1>,< >
	 elseifidn <char1>,<	>
	 else
	 txt CATSTR txt,<char1>
	 endif
	endm
	exitm <txt>
endm
;=======/
;=====<< VIRTUAL STATEMENT >>===\
virtual MACRO var1:VARARG
	local cName,cvfn,cvft,cvft2,fName,var2,baka2
	local desen,right_start,argsNum
	local RRS,RRS2,ParameterCheck,baka,ConstructorArgs,ParentArgs
	
	cName textequ <@current_class>
	
	if SpeedyClass
	  exitm
	endif
		
	ifidn <$>, @SubStr(<var1>,1,1) ; ignore old-style declaration of virtual destructor. 	
		exitm
	endif
	
	var2 textequ StripArguments(<var1>)
	ParameterCheck=0
	
	if @InStr(1,%var2,<:>)
		ParameterCheck = 1
		right_start = @InStr(1,%var2,<:>)
		if @SizeStr(%var2) eq right_start
			desen textequ <>
		else
			desen SUBSTR var2,right_start+1
		endif
		
		; now count the vars num
		
		argsNum=0
		%for arg,<desen>
		  argsNum = argsNum + 1
		endm
		;.err %argsNum
		;.err desen
		RRS= @InStr(1,%var2,<:>) 
		fName SUBSTR var2,1,RRS-1
		
	else
		fName textequ <var2>
		desen textequ <>
		argsNum = 1000
	endif
	
	;.err fName
	;.err desen
	;.err %argsNum
	;exitm
	
	;################  constructor changer
	ifidn cName,fName
		; ConstructorArgs,ParentArgs
		cvfn INSTR desen,<:>
		if cvfn
			ConstructorArgs SUBSTR desen,1,cvfn-1
			ParentArgs SUBSTR desen,cvfn+1		
			@CatStr(%cName,<_$ParentArgs>) textequ <&ParentArgs>
			@CatStr(%cName,<_$NewArgs>) textequ <&ConstructorArgs>
		else
			ConstructorArgs SUBSTR desen,1
			ParentArgs textequ <>
			@CatStr(%cName,<_$NewArgs>) textequ <&desen>
		endif
		
		
		exitm
	endif
	
	
	
	
	if FirstParameterIsMe
		ifdif desen,<>
			desen CATSTR <me,>,desen
		else
			desen CATSTR <me>
		endif
	endif
	
	
	
	
	
	cvft CATSTR cName,<_$vfn>
	cvfn equ cvft ; number of virtual funcs, already existing
	cvft CATSTR cName,<_$fn_>
	cvft CATSTR cvft,%cvfn
	@CatStr(cvft,< textequ <&fName>>)
	
	
	cvft CATSTR cName,<_>,fName,<$d>
	@CatStr(cvft,< textequ <&desen>>)
	
	cvft CATSTR cName,<_>,fName,<$argz>
	
	cvft = argsNum
	
	if DisplayClassHardMembers
		baka CATSTR %argsNum
	%echo cvft = baka
	endif
	
	cvft CATSTR cName,<_$vfn>
	cvft = cvft +1
endm
;=======/
;=====<< ENLIST CLASS VARS >>===\
@enlist_class_variables MACRO cName
	local ParentClass,baka,cvfn,cvft,cvft2,tName,cName2
	
	cName2 textequ <cName>
	
	
	
	ParentClass CATSTR cName2,<_$Parent>
	
	ifdif ParentClass,<>
		@enlist_class_variables <&ParentClass>
	endif
	
	
	;---< enlist variables >------------------------------------\
	cvft CATSTR cName2,<_$vn>
	cvfn equ cvft
	baka=0
    while baka LT cvfn ; for each variable in this class ...
	cvft CATSTR cName2,<_$vn_>
	cvft2 CATSTR cvft,%baka
	cvft2
	if DisplayClassHardcode
		%echo cvft2
	endif
	baka=baka+1
    endm
	;-----------------------------------------------------------/
	
	
endm
;=======/
;=====<< SET AND GET VAR >>===\
SetVar macro beg,endd,var1
	@CatStr(beg,endd) textequ <&var1>
endm	
GetVar macro beg,endd
	local ou 
	ou textequ &beg&endd
	exitm ou
endm
	
SetVar2 macro beg,va,endd,var1
	@CatStr(beg,<_>,va,endd) textequ <&var1>
endm	
GetVar2 macro beg,va,endd
	local ou 
	ou textequ &beg&_&va&endd
	exitm ou
endm

	
;=======/
;=====<< ADD VIRTUAL FUNC (REAL) >>===\
@AddVirtualFunction macro cName,cFunc
	local already_exists,bakale,ft,ft2,cFunc2,cFunc3,baka2kun,baka3,gClass,bakame,curCla,baka
	local sami,curClass,baka2
	sami textequ <$r>
	curClass textequ <@current_class>
	
	;---< check if virtual function has been already defined >---\
	already_exists = 0
	bakale = 0	
	cFunc2 textequ <cFunc>
    while bakale LT @global_done_virtuals
	cFunc3 CATSTR <@built_f_>,%bakale
	ifidn cFunc2,cFunc3
	  already_exists = bakale+1
	endif
    bakale = bakale + 1
    endm
	
	;------------------------------------------------------------/
	
	
	
	if already_exists eq 0
		@CatStr(<@built_f_>,%@global_done_virtuals) textequ cFunc
		@CatStr(<@built_f2_>,%@global_done_virtuals) CATSTR cName,<_>,cFunc
		@global_done_virtuals = @global_done_virtuals + 1
	else
	 @CatStr(<@built_f2_>,%(already_exists-1)) CATSTR cName,<_>,cFunc
	endif
	
	ifdifi cFunc,<__$delete>
		bakame CATSTR <_>, cFunc, <$r>  ;  CATSTR curClass,<_>,cFunc,<$r>
		baka CATSTR cName,<_>,cFunc
		@CatStr(%curClass,%bakame) textequ <&baka>
	endif
	
endm	
;=======/
;=====<< ENLIST CLASS VIRTUALS >>===\
@enlist_class_virtuals MACRO cName
	local ParentClass,baka,cvfn,cvft,tName
	local baka2,already_exists,fn,ft,ft2
	ParentClass CATSTR cName,<_$Parent>
	
	ifdif ParentClass,<>
		@enlist_class_virtuals &ParentClass
	endif
	
	
	
	;-------< enlist virtuals >----------------------------------------\
	cvft CATSTR cName,<_$vfn>
	cvfn equ cvft
	baka=0
    while baka LT cvfn ; for each virtual function in this class ...
	cvft CATSTR cName,<_$fn_>
	cvft CATSTR cvft,%baka
	
	;--< ADD VIRTUAL FUNCTION !>------------\*********************************************************
	; cName - cur class
	; cvft  - func name
	@AddVirtualFunction cName,cvft
	
	;---------------------------------------/*********************************************************
	
	@global_virtuals_num=@global_virtuals_num +1
	baka=baka+1
    endm
	;------------------------------------------------------------------/
	
endm
;=======/
;=====<< NEW and DELETE >>===\
	
HeapFree proto :DWORD,:DWORD,:DWORD
HeapAlloc proto :DWORD,:DWORD,:DWORD

malloc MACRO How:REQ
	invoke HeapAlloc,HEAP1,HEAP_ZERO_MEMORY,How
	exitm <eax>
ENDM
free MACRO What

	invoke HeapFree,HEAP1,0,What
ENDM
	
	
	
new2 MACRO What:REQ,ClassName:REQ,var1:VARARG
	local baka4,vara
	push eax
	push ecx
	push edi
	xor eax,eax
	mov ecx,sizeof ClassName
	mov edi,What
	rep stosb
	pop edi
	pop ecx
	pop eax
	
	mov ecx,What
	push eax
	mov dword ptr[ecx],offset ClassName&_$virt_table
	baka4 textequ <ClassName&_$NewArgs>
	ifb baka4
		invoke @CatStr(ClassName,<___>,ClassName) ; call the constructor, returned pointer in eax
	else
		for vara,<var1>
			ifidni <vara>,<ecx>
			.err <Please do not use ECX as a parameter in "new">
			endif
		endm
		invoke @CatStr(ClassName,<___>,ClassName),var1
	endif
	pop ecx
	mov eax,ecx ;ecx and eax should have the pointer ;)
endm

	
new MACRO ClassName:REQ,var1:VARARG
	local baka4,vara
	mov ecx,malloc(sizeof ClassName)
	push eax
	mov dword ptr[ecx],offset ClassName&_$virt_table
	baka4 textequ <ClassName&_$NewArgs>
	ifidn baka4,<>
		invoke @CatStr(ClassName,<___>,ClassName) ; call the constructor, returned pointer in eax
	else
		for vara,<var1>
			ifidni <vara>,<ecx>
			.err <Please do not use ECX as a parameter in "new">
			endif
		endm
		invoke @CatStr(ClassName,<___>,ClassName),var1
	endif
	pop ecx
	mov eax,ecx ;ecx and eax should have the pointer ;)
	exitm <eax>
endm
		
delete MACRO What
	mov ecx,What
	mov eax,[ecx]
	push 0
	call dword ptr[eax]
endm
	
;=======/
;=====<< iCall, nCall, oCall >>===\
	
Scall MACRO name:REQ,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20,p21,p22

    FOR arg,<p22,p21,p20,p19,p18,p17,p16,p15,p14,p13,\
             p12,p11,p10,p9,p8,p7,p6,p5,p4,p3,p2,p1>
      IFNB <arg>    ;; If not blank
        push arg    ;; push parameter
      ENDIF
    ENDM

    call name       ;; call the procedure

ENDM
ccall MACRO name:REQ,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20,p21,p22
	local stas
	stas=0
    FOR arg,<p22,p21,p20,p19,p18,p17,p16,p15,p14,p13,\
             p12,p11,p10,p9,p8,p7,p6,p5,p4,p3,p2,p1>
      IFNB <arg>    ;; If not blank
        push arg    ;; push parameter
	stas = stas +4
      ENDIF
    ENDM

    call name       ;; call the procedure
	if stas ne 0
		add esp,stas
	endif
ENDM


nCall macro What:REQ,FuncName:REQ,var1:VARARG
	ifidn DefaultClassName,<>
	  .err <Please set some default class, using "SetDefClass">
	  exitm
	endif	
	%iCall What,DefaultClassName,FuncName,var1
endm	
	
oCall macro FuncName:REQ,var1:VARARG
	ifidn DefaultClassName,<>
	  .err <Please set some default class, using "SetDefClass">
	  exitm
	endif	
	%iCall ecx,DefaultClassName,FuncName,var1
endm	
	
iCall macro What:REQ,ClassName:REQ,FuncName:REQ,var1:VARARG
	local baka,baka2,argsNum,thisArgsNum,origFunc,cvft,errTxt1,usesMyEcx,txt,arg
	push ecx
	ifdef AdjustClassStack
	  mov esp2,esp
	endif
	
	thisArgsNum=0
	usesMyEcx =0 
	FOR arg,<var1>
	IFNB <arg>
		thisArgsNum = thisArgsNum + 1
		ifidni <arg>,<ecx>
			usesMyEcx = 1
		endif
	ENDIF
	ENDM
	
	
   ifdef ClassName&_&FuncName&$
	baka = ClassName&_&FuncName&$
	origFunc CATSTR <ClassName>,<_>,<FuncName>,<$r>
	cvft CATSTR origFunc,<$argz>
	argsNum = cvft
	;.err %argsNum
	if argsNum ne 1000
		if argsNum ne thisArgsNum
			
			errTxt1 CATSTR <Parameters number is not >,%argsNum,<, you've forgotten/added some>
			.err errTxt1
			exitm
		endif
	endif
   else	
	.err <Function ClassName&_&FuncName not defined!!>
	exitm
   endif
	
	
   if ClassName&_$HasCode
     if usesMyEcx
	
	   txt textequ <>
	    txt TEXTEQU <>
	  % FOR arg, var1
	        txt CATSTR <arg>, <!,>, txt
	    ENDM
 	   txt SUBSTR  txt, 1, @SizeStr( %txt ) - 1
   	   txt CATSTR  <!<>, txt, <!>>
	
	% FOR arg,txt
	  IFNB <arg>
		push arg
	  ENDIF
	ENDM
	
	ifdifi <ecx>,<What>
  	 mov ecx,What
	endif
	if FirstParameterIsMe
		push ecx
	endif
	call origFunc
     else
	
	ifdifi <ecx>,<What>
  	 mov ecx,What
	endif
      if FirstParameterIsMe
	ifnb <var1>
		invoke origFunc,ecx,var1
	else
		invoke origFunc,ecx
	endif
      else
	ifnb <var1>
		invoke origFunc,&var1
	else
		invoke origFunc
	endif
      endif
     endif
	
	
   else
	   txt textequ <>
	    txt TEXTEQU <>
	  % FOR arg, var1
	        txt CATSTR <arg>, <!,>, txt
	    ENDM
 	   txt SUBSTR  txt, 1, @SizeStr( %txt ) - 1
   	   txt CATSTR  <!<>, txt, <!>>
	% FOR arg,txt
	  IFNB <arg>
		push arg
	  ENDIF
	ENDM
	
	ifdifi <ecx>,<What>
  	 mov ecx,What
	endif
	
	if FirstParameterIsMe
		push ecx
	endif
	
	mov eax,[ecx]
	mov eax,[eax+baka*4]
	call eax
   endif
	
	ifdef AdjustClassStack
	  mov esp,esp2
	endif
	pop ecx
endm 	
	
icall textequ <iCall> ; recommended for beginners
ncall textequ <nCall> ; Default Call (Normal Call)
ocall textequ <oCall> ; save-coder-time call
	
SetDefClass macro What
	DefaultClassName textequ <What>
endm	
	


	
	
	
;=======/	
;=====<< EnterHostedClass >>===\
	; beware of inverse logic. 
	; Read "HostedClass" as 
	;     "Should the wrapper expect code for this class' functions"
EnterHostedClass macro
	HostedClass=0
endm
	
LeaveHostedClass macro
	HostedClass=1
endm
	
;=======/	
	
;=====<< STACKSAVER >>===\
		
CTEXT macro Text:VARARG
        local szText
        .data
        szText byte Text, 0
        .code
        exitm <offset szText>        
endm
	
.data
	ThisStackSaver dd 128 dup (0)
	ThisStackSaver_num dd 0
.code	
	
ThisStackBad proc whatPos,whatDif
	local str1[200]:byte
 ifdef wsprintfA
	invoke wsprintfA,addr str1,CTEXT("Stack corruption before EIP %Xh   , stack difference is %li "),whatPos,whatDif
	
	; having pushed too much leads to negative difference, showed above.
	
	invoke MessageBox,0,addr str1,CTEXT("Stack error!"),MB_ICONEXCLAMATION
	
 endif
	ret
ThisStackBad endp
	
	
startstack macro
	push eax
	push ecx
	mov eax,esp
	mov ecx,ThisStackSaver_num
	mov ThisStackSaver[ecx*4],eax
	inc ThisStackSaver_num
	pop ecx
	pop eax
endm	
	
endstack macro
	local goodies,heree
  heree:
	push eax ; same pushes as above
	push ecx
	
	mov eax,esp
	dec ThisStackSaver_num
	mov ecx,ThisStackSaver_num
	sub eax,ThisStackSaver[ecx*4]
	jz goodies 
	mov esp,ThisStackSaver[ecx*4]
	invoke ThisStackBad,heree,eax
  goodies:
	
	pop ecx
	pop eax
endm	
;=======/
	
	
	
	